package sam.fol.antlr ; 

import org.antlr.runtime.* ; 
import sam.lang.* ; 
import sam.fol.* ; 
import java.io.* ; 

/**
  * First-order logic loader.
  */
public class FolLoader {

   public boolean error ; // bad source or bad data 

   public Fol fol ;  

   /** Load but note errors */
   public FolLoader(InputStream fol) { 
      this.error = false ; 
      try { 
         ANTLRInputStream input = 
             new ANTLRInputStream(fol);
         FolLexer lexer = new FolLexer(input);
         CommonTokenStream tokens = new CommonTokenStream(lexer);
         FolParser parser = new FolParser(tokens);
         parser.test();  // try to parse theory
         this.fol = parser.fol ; 
      } 
      catch(Exception xxx) { 
         System.out.println(xxx) ;  
         this.error = true ; 
      }
  }


}

