package sam.lang ; 

import java.io.* ; 
import java.util.* ; 

/**
  *  Similar functionality to previous ANTLR version.
  *  Various modifications/enhancements. 
  *  17 May 2014.
   */
public class CologLoader  {

   /*** resulting theory */
   public Theory theory ;
   /*** error flag -- true if any serious error */
   public boolean error ; 
   /*** the colog source code */
   public StringBuilder sourcecode ;
   /*** report on load and compilation */
   public String report ;

   private Vector<String> rules ;

   ///// fixed tokens
   
   public CologLoader(InputStream in) { 
      this.theory = null ;
      this.error = false ;
      this.sourcecode = new StringBuilder() ;
      this.report = "" ;
      ///// load source code as process buffer
      this.load(in) ; 
      /////  split the source into rules and the rules into ant and cons
   }

   // load source code for processing
   protected void load(InputStream in) { 
      try {
         BufferedReader br = 
           new BufferedReader(new InputStreamReader(in)) ;
         String line = "" ;
         while (line != null) { 
            line = br.readLine() ;  
            if (line != null) {
               sourcecode.append(line) ; 
               sourcecode.append("\n") ; 
            } 
         } br.close() ; 
      } 
      catch(Exception x) { 
         //System.out.println(x) ; 
         this.error = true ; 
         this.report = this.report.concat(x.toString()) ; 
      }
   }

   // try to pluck rules from source code,
   // then take more time/space to analyze predicates and terms 
   protected void removeComments() { 
      for (int i = 0 ; i < sourcecode.length() ; i++) { 
         
      }
   }

   public static void main(String[] args) { 
      try {
         InputStream in = new FileInputStream(new File(args[0].trim())) ;
         CologLoader loader = new CologLoader(in) ;
         //System.out.println("error="+loader.error) ;    
         //loader.sourcecode.trimToSize() ;  // no effect?
         System.out.println(loader.sourcecode) ;    
         System.out.println(loader.report) ; 
      } catch(Exception x) {System.out.println(x) ; }
   }   

}
