package sam.lang ; 

import java.util.* ;
import sam.util.* ; 

/**
  * sam.lang.Rule 
  * @version 9 April 2014
  * @author &copy;  John Fisher 
   */
public class Rule {
   /////
   public Functor annotation ; 
   public Conjunction antecedent ; 
   public Disjunction consequent ; 
   public int existential ;   // free variable in consequent
   public String[] varNames ; // used by ActiveRule to display bindings
   public int A,  // width of antecedent
              C,  // A + widest consequent
              U,  // number of universal variables in the antecedent, set by CologAnalyzer
              V ; // total number of variables, set by CologAnalyzer
   public boolean complex ;  // complex rule?  Set by CologAnalyzer
   public boolean factual ;  // has factual antecedent?  Set by CologAnalyzer
   public boolean subfactual ;  // has subfactual antecedent?  Set by CologAnalyzer
   public Index[] forward ;  // consequent factual checking

   // C => D
   public Rule(Conjunction c, Disjunction d) { 
      this.antecedent = c ; 
      this.consequent = d ; 
      this.A = this.antecedent.size() ; 
      int w = 0 ; 
      Iterator it = this.consequent.iterator() ; 
      while (it.hasNext()) { 
         int ww = ((Conjunction)it.next()).size() ; 
         if (ww > w) w = ww ; 
      }
      this.C = this.A + w ;  
      //this.complex = this.complex() ; // calculate it now
      // testing complexity calculations
      //System.out.println(this.complex+":"+complexity(antecedent)+"=>"+complexity(consequent)) ; 

   }

   /**
     *  Strict display as string 
     */
   public String toString() { 
      StringBuffer sb = new StringBuffer() ; 
      if (this.annotation != null) {
         sb.append(this.annotation.toString()) ; 
         sb.append(" : ") ; 
      }
      sb.append(this.antecedent.toString()) ; 
      sb.append(" => ") ; 
      sb.append(this.consequent.toString()) ; 
      return sb.toString() ; 
   }

/**
  *  Display this rule with HTML tags.
   */
   public String toHTML(boolean queue,int index,int size,int U) {
      StringBuffer sb = new StringBuffer() ; 
      sb.append("<html><tt><font size =\"") ;
      sb.append(size+"\">") ;
      if (queue) 
         sb.append("<font color = \"BLUE\">" +"[" + index + "] </font>" ) ;
      else sb.append("<font color = \"BLUE\">"  + index + " </font>" ) ;
      sb.append(this.antecedent.toHTML(U)) ;
      sb.append("<font color = \"GREEN\"> => </font>") ;
      Iterator it = this.consequent.iterator() ; 
      while (it.hasNext()) { 
         sb.append(((Conjunction)it.next()).toHTML(U)) ; // red flag existential variables
         if (it.hasNext())
            sb.append("<font color = \"GREEN\"> | </font>") ;
      }
      sb.append("</tt></font>"+ "<font color = \"GREEN\">.</font>") ;
      return sb.toString() ;  // 11/22/1012  a little fix
   }


} // end Rule



