Ltac gsplit :=
  match goal with 
    |- _ /\ _ => split; try gsplit
  end.

Ltac destruct_conjunction H :=
  let H0 := fresh "H" in
  let T := type of H in
  match T with 
    _ /\ _ => destruct H as [ H H0 ]; try destruct_conjunction H; try destruct_conjunction H0
  end.

Ltac destruct_conjunctions :=
  match goal with 
    H : _ /\ _ |- _ => destruct_conjunction H
  end.

Ltac conjunctive_reasoning :=
  destruct_conjunctions; gsplit; try assumption.

Ltac permuted_conjunction_of H :=
  destruct_conjunction H; gsplit; assumption.

Ltac destruct_disjunction H :=
  let T := type of H in 
  match T with 
    _ \/ _ => destruct H as [ H | H ]; try destruct_disjunction H
  end.

Ltac destruct_disjunctions :=
  match goal with 
    H : _ \/ _ |- _ => destruct_disjunction H; try destruct_disjunctions
  end.

Ltac branch :=
  match goal with 
    |- _ \/ _ => (left; (assumption || branch)) || (right; (assumption || branch))
  end.

Ltac permuted_disjunction_of H :=
  destruct_disjunction H; branch; assumption.
