% name(cro_8_2). translated from Hendricks'
% http://www.few.vu.nl/~RDA.Hendriks/coq/hessenberg/cro_8_2.in

% domain elements
% points
true => dom(a1), dom(a2), dom(a3),
   dom(b1), dom(b2), dom(b3),
   dom(s),
   dom(p1), dom(p2), dom(p3),

% lines
   dom(a1a2), dom(a2a3), dom(a3a1),
   dom(b1b2), dom(b2b3), dom(b3b1),
   dom(s1), dom(s2), dom(s3).

% goal
i(p3,L),i(p1,L),i(p2,L) => goal.
i(a1,b2b3),i(a2,b3b1),i(a3,b1b2) => goal.
i(b1,a2a3),i(b2,a3a1),i(b3,a1a2) => goal.

% Desargues' assumptions: points, lines and incidences

% triangle a1a2a3
true => i(a1,a1a2), i(a2,a1a2), i(a2,a2a3),
        i(a3,a2a3), i(a3,a3a1), i(a1,a3a1).

% triangle b1b2b3
true => i(b1,b1b2), i(b2,b1b2), i(b2,b2b3),
        i(b3,b2b3), i(b3,b3b1), i(b1,b3b1).

% lines through perspectivity point s and corresponding vertices
true => i(s,s1), i(s,s2), i(s,s3),
        i(a1,s1), i(a2,s2), i(a3,s3),
        i(b1,s1), i(b2,s2), i(b3,s3).

% meet a1a2,b1b2 in point p3
true => i(p3,a1a2), i(p3,b1b2).

% meet a2a3,b2b3 in point p1
true => i(p1,a2a3), i(p1,b2b3).

% meet a3a1,b3b1 in point p2
true => i(p2,a3a1), i(p2,b3b1).

% distinct points ai
e(a1,a2) => false.
e(a2,a3) => false.
e(a3,a1) => false.

% distinct points bi
e(b1,b2) => false.
e(b2,b3) => false.
e(b3,b1) => false.

% no corresponding edges in common
e(a1a2,b1b2) => false. 
e(a2a3,b2b3) => false. 
e(a3a1,b3b1) => false.

% equality
dom(X) => e(X,X).     
e(X,Y) => e(Y,X).
e(X,Y),e(Y,Z) => e(X,Z).

% congruence
e(P,Q),i(Q,L) => i(P,L).
i(P,L),e(L,M) => i(P,M).

% sorted incidence
i(P,L) => p(P).
i(P,L) => l(L).

true => i(a1,b2b3) ; i(b3,a1a2).
true => i(a2,b3b1) ; i(b1,a2a3).
true => i(a3,b1b2) ; i(b2,a3a1).

% projective uniqueness
i(P,L),i(P,M),i(Q,L),i(Q,M) => e(P,Q) ; e(L,M).

% projective geometry
l(L),l(M) => dom(P),i(P,L),i(P,M).
p(P),p(Q) => dom(L),i(P,L),i(Q,L).
